#include <mega8.h>
#include <delay.h>

/* ******************************************************************************************************************/
#define RED PORTB.0
#define GREEN PORTB.1
#define BLUE PORTB.2
/********************************************************************************************************************************/



/* ***********************************************************************************************************/
unsigned char red=255,   green,     blue;       //,      
unsigned char red_b,     green_b,   blue_b;     //,     
unsigned char count;                            //-    
unsigned char temp=1;                           //     
/********************************************************************************************************************************/



/* **********************************************************************************************************/
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
count++;
if (count == 0){                                //      0
        
        red_b   = red;                          //   
        green_b = green; 
        blue_b  = blue;
        
        RED   = 1;                               // ,      1
        GREEN = 1; 
        BLUE  = 1;                 
        
        }

if (red_b   == count) { RED   = 0;}             //      0   
if (green_b == count) { GREEN = 0;}
if (blue_b  == count) { BLUE  = 0;}
}
/********************************************************************************************************************************/



/* ****************************************************************************************************************/
void main(void)
{

PORTB=0x08;                                     // 
DDRB=0x07;

TCCR0=0x01;                                     // 
TCNT0=0x00;

TIMSK=0x01;                                     //      T0

#asm("sei")                                     //  


/* ***************************************************************************************************************/
while (1)                                       
      {
        if (temp==1) {if (green < 255)   green += 1; else temp = 2;}                                                
        if (temp==2) {if (red   >   0)   red   -= 1; else temp = 3;}                              
        if (temp==3) {if (blue  < 255)   blue  += 1; else temp = 4;}  
        if (temp==4) {if (green >   0)   green -= 1; else temp = 5;}  
        if (temp==5) {if (red   < 255)   red   += 1; else temp = 6;}  
        if (temp==6) {if (blue  >   0)   blue  -= 1; else temp = 1;}
        
        delay_ms(2);   

      };
}
/********************************************************************************************************************************/